# std::bitset< Nb > Class Template Reference
[Containers]

The bitset class represents a fixed-size sequence of bits. More...

List of all members.

## Public Member Functions

| bitset ()
| All bits set to zero.
| bitset (unsigned long __val)
| Initial bits bitwise-copied from a single word (others set to zero).
template<class CharT, class Traits, class Alloc> | bitset (const basic_string< CharT, Traits, Alloc > &s, size_t position=0)
| Use a subset of a string.
template<class CharT, class Traits, class Alloc> | bitset (const basic_string< CharT, Traits, Alloc > &s, size_t position, size_t n)
| Use a subset of a string.
bitset< Nb > & | set ()
| Sets every bit to true.
bitset< Nb > & | set (size_t position, bool __val=true)
| Sets a given bit to a particular value.
bitset< Nb > & | reset ()
| Sets every bit to false.
bitset< Nb > & | reset (size_t position)
| Sets a given bit to false.
bitset< Nb > & | flip ()
| Toggles every bit to its opposite value.
bitset< Nb > & | flip (size_t position)
| Toggles a given bit to its opposite value.
bitset< Nb > | operator~ () const
| See the no-argument flip().
unsigned long | to_ulong () const
| Retuns a numerical interpretation of the bitset.
template<class CharT, class Traits, class Alloc> basic_string< CharT, Traits, Alloc > | to_string () const
| Retuns a character interpretation of the bitset.
size_t | count () const
| Returns the number of bits which are set.
size_t | size () const
| Returns the total number of bits.
bool | test (size_t position) const
| Tests the value of a bit.
bool | any () const
| Tests whether any of the bits are on.
bool | none () const
| Tests whether any of the bits are on.
size_t | Find_first () const
| Finds the index of the first "on" bit.
size_t | Find_next (size_t __prev) const
| Finds the index of the next "on" bit after prev.
bitset< Nb > & | operator &= (const bitset< Nb > &__rhs)
| Operations on bitsets.
bitset< Nb > & | operator|= (const bitset< Nb > &__rhs)
| Operations on bitsets.
bitset< Nb > & | operator^= (const bitset< Nb > &__rhs)
| Operations on bitsets.
bitset< Nb > & | operator<<= (size_t position)
| Operations on bitsets.
bitset< Nb > & | operator>>= (size_t position)
| Operations on bitsets.
bitset< Nb > & | Unchecked_set (size_t position)
bitset< Nb > & | Unchecked_set (size_t position, int __val)
bitset< Nb > & | Unchecked_reset (size_t position)
bitset< Nb > & | Unchecked_flip (size_t position)
bool | Unchecked_test (size_t position) const
reference | operator[] (size_t position)
| Array-indexing support.
bool | operator[] (size_t position) const
| Array-indexing support.
bool | operator== (const bitset< Nb > &__rhs) const
| These comparisons for equality/inequality are, well, bitwise.
bool | operator!= (const bitset< Nb > &__rhs) const
| These comparisons for equality/inequality are, well, bitwise.
bitset< Nb > | operator<< (size_t position) const
| Self-explanatory.
bitset< Nb > | operator>> (size_t position) const
| Self-explanatory.

## Detailed Description

### template<size_t Nb>
class std::bitset< Nb >

The bitset class represents a fixed-size sequence of bits.

(Note that bitset does not meet the formal requirements of a container. Mainly, it lacks iterators.)

The template argument, Nb, may be any non-negative number, specifying the number of bits (e.g., "0", "12", "1024*1024").

In the general unoptimized case, storage is allocated in word-sized blocks. Let B be the number of bits in a word, then (Nb+(B-1))/B words will be used for storage. B - Nb%B bits are unused. (They are the high-order bits in the highest word.) It is a class invariant that those unused bits are always zero.

If you think of bitset as "a simple array of bits," be aware that your mental picture is reversed: a bitset behaves the same way as bits in integers do, with the bit at index 0 in the "least significant / right-hand" position, and the bit at index Nb-1 in the "most significant / left-hand" position. Thus, unlike other containers, a bitset's index "counts from right to left," to put it very loosely.

This behavior is preserved when translating to and from strings. For example, the first line of the following program probably prints "b('a') is 0001100001" on a modern ASCII system.

         #include <bitset>
         #include <iostream>
         #include <sstream>

         using namespace std;

         int main()
         {
             long         a = 'a';
             bitset<10>   b(a);

             cout << "b('a') is " << b << endl;

             ostringstream s;
             s << b;
             string  str = s.str();
             cout << "index 3 in the string is " << str[3] << " but\n"
                  << "index 3 in the bitset is " << b[3] << endl;
         }

Also see http://gcc.gnu.org/onlinedocs/libstdc++/ext/sgiexts.html#ch23 for a description of extensions.

Definition at line 646 of file bitset.

## Constructor & Destructor Documentation

template<size_t Nb>
std::bitset< Nb >::bitset | ( |  | ) | `[inline]`

| All bits set to zero. Definition at line 736 of file bitset.

template<size_t Nb>
std::bitset< Nb >::bitset | ( | unsigned long | __val | ) | `[inline]`

| Initial bits bitwise-copied from a single word (others set to zero). Definition at line 740 of file bitset.

template<size_t Nb>
template<class CharT, class Traits, class Alloc>
std::bitset< Nb >::bitset | ( | const basic_string< CharT, Traits, Alloc > & | s,
|  | size_t | position = `0`
| ) | `[inline, explicit]`

Use a subset of a string.

Parameters:

  | s | A string of '0' and '1' characters.
  | position | Index of the first character in s to use; defaults to zero.

Exceptions:

  | std::out_of_range | If pos is bigger the size of s.
  | std::invalid_argument | If a character appears in the string which is neither '0' nor '1'.

Definition at line 755 of file bitset.

References std::basic_string< CharT, Traits, Alloc >::size().

template<size_t Nb>
template<class CharT, class Traits, class Alloc>
std::bitset< Nb >::bitset | ( | const basic_string< CharT, Traits, Alloc > & | s,
|  | size_t | position,
|  | size_t | n
| ) | `[inline]`

Use a subset of a string.

Parameters:

  | s | A string of '0' and '1' characters.
  | position | Index of the first character in s to use.
  | n | The number of characters to copy.

Exceptions:

  | std::out_of_range | If pos is bigger the size of s.
  | std::invalid_argument | If a character appears in the string which is neither '0' nor '1'.

Definition at line 776 of file bitset.

References std::basic_string< CharT, Traits, Alloc >::size().

## Member Function Documentation

template<size_t Nb>
bool std::bitset< Nb >::any | ( |  | ) | const`[inline]`

Tests whether any of the bits are on.

Returns:
  True if at least one bit is set.

Definition at line 1082 of file bitset.

template<size_t Nb>
size_t std::bitset< Nb >::count | ( |  | ) | const`[inline]`

| Returns the number of bits which are set. Definition at line 1044 of file bitset.

template<size_t Nb>
bitset<Nb>& std::bitset< Nb >::flip | ( | size_t | position | ) | `[inline]`

Toggles a given bit to its opposite value.

Parameters:

  | position | The index of the bit.

Exceptions:

  | std::out_of_range | If pos is bigger the size of the set.

Definition at line 961 of file bitset.

template<size_t Nb>
bitset<Nb>& std::bitset< Nb >::flip | ( |  | ) | `[inline]`

| Toggles every bit to its opposite value. Definition at line 948 of file bitset.

template<size_t Nb>
bool std::bitset< Nb >::none | ( |  | ) | const`[inline]`

Tests whether any of the bits are on.

Returns:
  True if none of the bits are set.

Definition at line 1090 of file bitset.

template<size_t Nb>
bitset<Nb>& std::bitset< Nb >::operator &= | ( | const bitset< Nb > & | __rhs | ) | `[inline]`

Operations on bitsets.

Parameters:

  | rhs | A same-sized bitset.

These should be self-explanatory.

Definition at line 795 of file bitset.

template<size_t Nb>
bool std::bitset< Nb >::operator!= | ( | const bitset< Nb > & | __rhs | ) | const`[inline]`

| These comparisons for equality/inequality are, well, bitwise. Definition at line 1059 of file bitset.

template<size_t Nb>
bitset<Nb> std::bitset< Nb >::operator<< | ( | size_t | position | ) | const`[inline]`

| Self-explanatory. Definition at line 1096 of file bitset.

template<size_t Nb>
bitset<Nb>& std::bitset< Nb >::operator<<= | ( | size_t | position | ) | `[inline]`

Operations on bitsets.

Parameters:

  | position | The number of places to shift.

These should be self-explanatory.

Definition at line 824 of file bitset.

References std::bitset< Nb >::operator<<=().

Referenced by std::bitset< Nb >::operator<<=().

template<size_t Nb>
bool std::bitset< Nb >::operator== | ( | const bitset< Nb > & | __rhs | ) | const`[inline]`

| These comparisons for equality/inequality are, well, bitwise. Definition at line 1055 of file bitset.

template<size_t Nb>
bitset<Nb> std::bitset< Nb >::operator>> | ( | size_t | position | ) | const`[inline]`

| Self-explanatory. Definition at line 1100 of file bitset.

template<size_t Nb>
bitset<Nb>& std::bitset< Nb >::operator>>= | ( | size_t | position | ) | `[inline]`

Operations on bitsets.

Parameters:

  | position | The number of places to shift.

These should be self-explanatory.

Definition at line 837 of file bitset.

References std::bitset< Nb >::operator>>=().

Referenced by std::bitset< Nb >::operator>>=().

template<size_t Nb>
bool std::bitset< Nb >::operator[] | ( | size_t | position | ) | const`[inline]`

Array-indexing support.

Parameters:

  | position | Index into the bitset.

Returns:
  A bool for a 'const bitset'. For non-const bitsets, an instance of the reference proxy class.

Note:
  These operators do no range checking and throw no exceptions, as required by DR 11 to the standard.

Definition at line 995 of file bitset.

References std::bitset< Nb >::operator[]().

template<size_t Nb>
reference std::bitset< Nb >::operator[] | ( | size_t | position | ) | `[inline]`

Array-indexing support.

Parameters:

  | position | Index into the bitset.

Returns:
  A bool for a 'const bitset'. For non-const bitsets, an instance of the reference proxy class.

Note:
  These operators do no range checking and throw no exceptions, as required by DR 11 to the standard.

Definition at line 991 of file bitset.

References std::bitset< Nb >::operator[]().

Referenced by std::bitset< Nb >::operator[]().

template<size_t Nb>
bitset<Nb>& std::bitset< Nb >::operator^= | ( | const bitset< Nb > & | __rhs | ) | `[inline]`

Operations on bitsets.

Parameters:

  | rhs | A same-sized bitset.

These should be self-explanatory.

Definition at line 809 of file bitset.

References std::bitset< Nb >::operator^=().

Referenced by std::bitset< Nb >::operator^=().

template<size_t Nb>
bitset<Nb>& std::bitset< Nb >::operator|= | ( | const bitset< Nb > & | __rhs | ) | `[inline]`

Operations on bitsets.

Parameters:

  | rhs | A same-sized bitset.

These should be self-explanatory.

Definition at line 802 of file bitset.

References std::bitset< Nb >::operator|=().

Referenced by std::bitset< Nb >::operator|=().

template<size_t Nb>
bitset<Nb> std::bitset< Nb >::operator~ | ( |  | ) | const`[inline]`

| See the no-argument flip(). Definition at line 970 of file bitset.

template<size_t Nb>
bitset<Nb>& std::bitset< Nb >::reset | ( | size_t | position | ) | `[inline]`

Sets a given bit to false.

Parameters:

  | position | The index of the bit.

Exceptions:

  | std::out_of_range | If pos is bigger the size of the set.

Same as writing `set(pos,false)`.

Definition at line 937 of file bitset.

template<size_t Nb>
bitset<Nb>& std::bitset< Nb >::reset | ( |  | ) | `[inline]`

| Sets every bit to false. Definition at line 923 of file bitset.

template<size_t Nb>
bitset<Nb>& std::bitset< Nb >::set | ( | size_t | position,
|  | bool | __val = `true`
| ) | `[inline]`

Sets a given bit to a particular value.

Parameters:

  | position | The index of the bit.
  | val | Either true or false, defaults to true.

Exceptions:

  | std::out_of_range | If pos is bigger the size of the set.

Definition at line 912 of file bitset.

template<size_t Nb>
bitset<Nb>& std::bitset< Nb >::set | ( |  | ) | `[inline]`

| Sets every bit to true. Definition at line 898 of file bitset.

template<size_t Nb>
size_t std::bitset< Nb >::size | ( |  | ) | const`[inline]`

| Returns the total number of bits. Definition at line 1049 of file bitset.

template<size_t Nb>
bool std::bitset< Nb >::test | ( | size_t | position | ) | const`[inline]`

Tests the value of a bit.

Parameters:

  | position | The index of a bit.

Returns:
  The value at pos.

Exceptions:

  | std::out_of_range | If pos is bigger the size of the set.

Definition at line 1070 of file bitset.

References std::bitset< Nb >::test().

Referenced by std::bitset< Nb >::test().

template<size_t Nb>
template<class CharT, class Traits, class Alloc>
basic_string<CharT, Traits, Alloc> std::bitset< Nb >::to_string | ( |  | ) | const`[inline]`

Retuns a character interpretation of the bitset.

Returns:
  The string equivalent of the bits.

Note the ordering of the bits: decreasing character positions correspond to increasing bit positions (see the main class notes for an example).

Also note that you must specify the string's template parameters explicitly. Given a bitset `bs` and a string :

         s = bs.to_string<char,char_traits<char>,allocator<char> >();

Definition at line 1025 of file bitset.

template<size_t Nb>
unsigned long std::bitset< Nb >::to_ulong | ( |  | ) | const`[inline]`

Retuns a numerical interpretation of the bitset.

Returns:
  The integral equivalent of the bits.

Exceptions:

  | std::overflow_error | If there are too many bits to be represented in an `unsigned` `long`.

Definition at line 1006 of file bitset.

The documentation for this class was generated from the following file:

- bitset